searchNodes=[{"doc":"A set of functions to mimic the standard Haskell libraries feature a number of type classes with algebraic or category-theoretic underpinnings. The functions in this module come in two flavors: named or operators. For example: iex&gt; use Realm iex&gt; append(1, 1) # named 2 iex&gt; 1 &lt;&gt; 1 # operator 2 If you prefer to use only operators or skip them, you can pass the following options: :only_operators - includes only operators :skip_operators - skips operators For example: iex&gt; use Realm, onlyoperators: true iex&gt; 1 &lt;&gt; 1 2 When invoked with no options, use Realm is equivalent to import Realm. All bitwise functions can be used in guards: iex&gt; appendable? = fn ...&gt; semigroup when Realm.append(semigroup, 1) == 2 -&gt; true ...&gt; -&gt; false ...&gt; end iex&gt; appendable?.(1) true","ref":"Realm.html","title":"Realm","type":"module"},{"doc":"The opposite of equivalent?/2. Examples iex&gt; 1 != 2 true","ref":"Realm.html#!=/2","title":"Realm.!=/2","type":"function"},{"doc":"Duplicate incoming data into both halves of a 2-tuple, and run one function on the left copy, and a different function on the right copy. ┌------&gt; f.(a) = x ------┐ | v a ---&gt; split = {a, a} {x, y} | ^ └------&gt; g.(a) = y ------┘ Examples iex&gt; fanned = fn x -&gt; x - 10 end &amp;&amp;&amp; fn y -&gt; inspect(y) &lt;&gt; &quot;!&quot; end ...&gt; fanned.(42) {32, &quot;42!&quot;} iex&gt; fanned = ...&gt; fn x -&gt; x - 10 end ...&gt; &amp;&amp;&amp; fn y -&gt; inspect(y) &lt;&gt; &quot;!&quot; end ...&gt; &amp;&amp;&amp; fn z -&gt; inspect(z) &lt;&gt; &quot;?&quot; end ...&gt; &amp;&amp;&amp; fn d -&gt; inspect(d) &lt;&gt; inspect(d) end ...&gt; &amp;&amp;&amp; fn e -&gt; e / 2 end ...&gt; ...&gt; fanned.(42) {{{{32, &quot;42!&quot;}, &quot;42?&quot;}, &quot;4242&quot;}, 21.0}","ref":"Realm.html#&&&/2","title":"Realm.&&&/2","type":"function"},{"doc":"Determine if an element is :lesser than another. Examples iex&gt; 1 &lt; 1 false iex&gt; 1 &lt; 1.1 true","ref":"Realm.html#%3C/2","title":"Realm.</2","type":"function"},{"doc":"Same as ap/2, but with all functions curried. Examples iex&gt; [fn x -&gt; x + 1 end, fn y -&gt; y * 10 end] &lt;&lt;~ [1, 2, 3] [2, 3, 4, 10, 20, 30] iex&gt; import Realm.Functor ...&gt; ...&gt; [100, 200] ...&gt; ~&gt; fn(x, y, z) -&gt; x * y / z ...&gt; end &lt;&lt;~ [5, 2] ...&gt; &lt;&lt;~ [100, 50] ...&gt; ~&gt; fn x -&gt; x + 1 end [6.0, 11.0, 3.0, 5.0, 11.0, 21.0, 5.0, 9.0] iex&gt; import Realm.Functor, only: [&lt;~: 2] ...&gt; fn(a, b, c, d) -&gt; a * b - c + d end &lt;~ [1, 2] &lt;&lt;~ [3, 4] &lt;&lt;~ [5, 6] &lt;&lt;~ [7, 8] [5, 6, 4, 5, 6, 7, 5, 6, 8, 9, 7, 8, 10, 11, 9, 10]","ref":"Realm.html#%3C%3C~/2","title":"Realm.<<~/2","type":"function"},{"doc":"Determine if an element is :lesser or :equal to another. Examples iex&gt; use Realm.Ord ...&gt; 1 &lt;= 2 true ...&gt; [] &lt;= [1, 2, 3] false ...&gt; [1] &lt;= [1, 2, 3] true ...&gt; [4] &lt;= [1, 2, 3] false","ref":"Realm.html#%3C=/2","title":"Realm.<=/2","type":"function"},{"doc":"There is an operator alias a &lt;&gt; b. Since this conflicts with Kernel.&lt;&gt;/2, use Realm,Semigroup will automatically exclude the Kernel operator. This is highly recommended, since &lt;&gt; behaves the same on bitstrings, but is now available on more datatypes. Examples iex&gt; use Realm.Semigroup ...&gt; 1 &lt;&gt; 2 &lt;&gt; 3 &lt;&gt; 5 &lt;&gt; 7 18 iex&gt; use Realm.Semigroup ...&gt; [1, 2, 3] &lt;&gt; [4, 5, 6] &lt;&gt; [7, 8, 9] [1, 2, 3, 4, 5, 6, 7, 8, 9] iex&gt; use Realm.Semigroup ...&gt; &quot;foo&quot; &lt;&gt; &quot; &quot; &lt;&gt; &quot;bar&quot; &quot;foo bar&quot;","ref":"Realm.html#%3C%3E/2","title":"Realm.<>/2","type":"function"},{"doc":"Composition operator &quot;the math way&quot;. Alias for compose/2. Examples iex&gt; times_ten_plus_one = ...&gt; fn x -&gt; x + 1 end ...&gt; &lt;|&gt; fn y -&gt; y * 10 end ...&gt; ...&gt; times_ten_plus_one.(5) 51","ref":"Realm.html#%3C%7C%3E/2","title":"Realm.<|>/2","type":"function"},{"doc":"lift/2 but with arguments flipped. iex&gt; (fn x -&gt; x + 5 end) &lt;~ [1,2,3] [6, 7, 8] Note that the mnemonic is flipped from |&gt;, and combinging directions can be confusing. It&#39;s generally recommended to use ~&gt;, or to keep &lt;~ on the same line both of it&#39;s arguments: iex&gt; fn(x, y) -&gt; x + y end &lt;~ [1, 2, 3] ...&gt; |&gt; List.first() ...&gt; |&gt; apply([9]) 10 ...or in an expression that&#39;s only pointing left: iex&gt; fn y -&gt; y * 10 end ...&gt; &lt;~ fn x -&gt; x + 55 end ...&gt; &lt;~ [1, 2, 3] [560, 570, 580]","ref":"Realm.html#%3C~/2","title":"Realm.<~/2","type":"function"},{"doc":"Composition operator &quot;the pipe way&quot;. Alias for compose/2. Examples iex&gt; times_ten_plus_one = ...&gt; fn y -&gt; y * 10 end ...&gt; &lt;~&gt; fn x -&gt; x + 1 end ...&gt; ...&gt; times_ten_plus_one.(5) 51","ref":"Realm.html#%3C~%3E/2","title":"Realm.<~>/2","type":"function"},{"doc":"Determine if an element is equal to another. Examples iex&gt; use Realm.Ord ...&gt; 2 == 1 false ...&gt; 1 == 1 true","ref":"Realm.html#==/2","title":"Realm.==/2","type":"function"},{"doc":"Determine if an element is :greater than another. Examples iex&gt; 1 &gt; 1 false iex&gt; 1.1 &gt; 1 true","ref":"Realm.html#%3E/2","title":"Realm.>/2","type":"function"},{"doc":"Determine if an element is :greater or :equal to another. Examples iex&gt; use Realm.Ord ...&gt; at_least?(2, 1) true ...&gt; at_least?([1, 2, 3], []) true ...&gt; at_least?([1, 2, 3], [1]) true ...&gt; at_least?([1, 2, 3], [4]) false","ref":"Realm.html#%3E=/2","title":"Realm.>=/2","type":"function"},{"doc":"Take two arguments (as a 2-tuple), and run one function on the left side (first element), and run a different function on the right side (second element). ┌------&gt; f.(a) = x -------┐ | v {a, b} {x, y} | ^ └------&gt; g.(b) = y -------┘ Examples iex&gt; arr = fn x -&gt; x - 10 end ^^^ fn y -&gt; y &lt;&gt; &quot;!&quot; end ...&gt; arr.({42, &quot;Hi&quot;}) {32, &quot;Hi!&quot;} iex&gt; {42, &quot;Hi&quot;} |&gt; (fn x -&gt; x - 10 end ^^^ fn y -&gt; y &lt;&gt; &quot;!&quot; end).() {32, &quot;Hi!&quot;}","ref":"Realm.html#%5E%5E%5E/2","title":"Realm.^^^/2","type":"function"},{"doc":"There is an operator alias a &lt;&gt; b. Since this conflicts with Kernel.&lt;&gt;/2, use Realm,Semigroup will automatically exclude the Kernel operator. This is highly recommended, since &lt;&gt; behaves the same on bitstrings, but is now available on more datatypes. Examples iex&gt; use Realm.Semigroup ...&gt; 1 &lt;&gt; 2 &lt;&gt; 3 &lt;&gt; 5 &lt;&gt; 7 18 iex&gt; use Realm.Semigroup ...&gt; append([1, 2, 3], [4, 5, 6]) |&gt; append([7, 8, 9]) [1, 2, 3, 4, 5, 6, 7, 8, 9] iex&gt; use Realm.Semigroup ...&gt; append(&quot;foo&quot;, &quot; &quot;) |&gt; append(&quot;bar&quot;) &quot;foo bar&quot;","ref":"Realm.html#append/2","title":"Realm.append/2","type":"function"},{"doc":"Determine if an element is :greater or :equal to another. Examples iex&gt; use Realm.Ord ...&gt; 2 &gt;= 1 true ...&gt; [1, 2, 3] &gt;= [] true ...&gt; [1, 2, 3] &gt;= [1] true ...&gt; [1, 2, 3] &gt;= [4] false","ref":"Realm.html#at_least?/2","title":"Realm.at_least?/2","type":"function"},{"doc":"Determine if an element is :lesser or :equal to another. Examples iex&gt; use Realm.Ord ...&gt; at_most?(1, 2) true ...&gt; at_most?([], [1, 2, 3]) false ...&gt; at_most?([1], [1, 2, 3]) true ...&gt; at_most?([4], [1, 2, 3]) false","ref":"Realm.html#at_most?/2","title":"Realm.at_most?/2","type":"function"},{"doc":"Composition operator &quot;the math way&quot;. Alias for compose/2. Examples iex&gt; times_ten_plus_one = compose(fn x -&gt; x + 1 end, fn y -&gt; y * 10 end) ...&gt; ...&gt; times_ten_plus_one.(5) 51","ref":"Realm.html#compose/2","title":"Realm.compose/2","type":"function"},{"doc":"Determine if an element is equal to another. Examples iex&gt; use Realm.Ord ...&gt; equal?(2, 1) false ...&gt; equal?(1, 1) true","ref":"Realm.html#equal?/2","title":"Realm.equal?/2","type":"function"},{"doc":"Duplicate incoming data into both halves of a 2-tuple, and run one function on the left copy, and a different function on the right copy. ┌------&gt; f.(a) = x ------┐ | v a ---&gt; split = {a, a} {x, y} | ^ └------&gt; g.(a) = y ------┘ Examples iex&gt; fanned = fn x -&gt; x - 10 end &amp;&amp;&amp; fn y -&gt; inspect(y) &lt;&gt; &quot;!&quot; end ...&gt; fanned.(42) {32, &quot;42!&quot;} iex&gt; fanned = ...&gt; fanout(fn x -&gt; x - 10 end, fn y -&gt; inspect(y) &lt;&gt; &quot;!&quot; end) ...&gt; |&gt; fanout(fn z -&gt; inspect(z) &lt;&gt; &quot;?&quot; end) ...&gt; |&gt; fanout(fn d -&gt; inspect(d) &lt;&gt; inspect(d) end) ...&gt; |&gt; fanout(fn e -&gt; e / 2 end) ...&gt; ...&gt; fanned.(42) {{{{32, &quot;42!&quot;}, &quot;42?&quot;}, &quot;4242&quot;}, 21.0}","ref":"Realm.html#fanout/2","title":"Realm.fanout/2","type":"function"},{"doc":"Composition operator &quot;the pipe way&quot;. Alias for compose/2. Examples iex&gt; times_ten_plus_one = flow_compose(fn y -&gt; y * 10 end, fn x -&gt; x + 1 end) ...&gt; ...&gt; times_ten_plus_one.(5) 51","ref":"Realm.html#flow_compose/2","title":"Realm.flow_compose/2","type":"function"},{"doc":"Determine if an element is :greater than another. Examples iex&gt; greater?(1, 1) false iex&gt; greater?(1.1, 1) true","ref":"Realm.html#greater?/2","title":"Realm.greater?/2","type":"function"},{"doc":"Determine if an element is :lesser than another. Examples iex&gt; lesser?(1, 1) false iex&gt; lesser?(1, 1.1) true","ref":"Realm.html#lesser?/2","title":"Realm.lesser?/2","type":"function"},{"doc":"map/2 but with the function automatically curried Examples iex&gt; lift([1, 2, 3], fn x -&gt; x + 55 end) ...&gt; |&gt; lift(fn y -&gt; y * 10 end) [560, 570, 580] iex&gt; lift([1, 2, 3], fn(x, y) -&gt; x + y end) ...&gt; |&gt; List.first() ...&gt; |&gt; apply([9]) 10","ref":"Realm.html#lift/2","title":"Realm.lift/2","type":"function"},{"doc":"The opposite of equivalent?/2. Examples iex&gt; nonequivalent?(1, 2) true","ref":"Realm.html#nonequivalent?/2","title":"Realm.nonequivalent?/2","type":"function"},{"doc":"lift/2 but with arguments flipped. iex&gt; lift(fn x -&gt; x + 5 end, [1,2,3]) [6, 7, 8] Note that the mnemonic is flipped from |&gt;, and combinging directions can be confusing. It&#39;s generally recommended to use ~&gt;, or to keep &lt;~ on the same line both of it&#39;s arguments: iex&gt; over(fn(x, y) -&gt; x + y end, [1, 2, 3]) ...&gt; |&gt; List.first() ...&gt; |&gt; apply([9]) 10 ...or in an expression that&#39;s only pointing left: iex&gt; over(fn y -&gt; y * 10 end, fn x -&gt; x + 55 end) ...&gt; |&gt; over([1, 2, 3]) [560, 570, 580]","ref":"Realm.html#over/2","title":"Realm.over/2","type":"function"},{"doc":"Take two arguments (as a 2-tuple), and run one function on the left side (first element), and run a different function on the right side (second element). ┌------&gt; f.(a) = x -------┐ | v {a, b} {x, y} | ^ └------&gt; g.(b) = y -------┘ Examples iex&gt; arr = product(fn x -&gt; x - 10 end, fn y -&gt; y &lt;&gt; &quot;!&quot; end) ...&gt; arr.({42, &quot;Hi&quot;}) {32, &quot;Hi!&quot;} iex&gt; {42, &quot;Hi&quot;} |&gt; product(fn x -&gt; x - 10 end, fn y -&gt; y &lt;&gt; &quot;!&quot; end).() {32, &quot;Hi!&quot;}","ref":"Realm.html#product/2","title":"Realm.product/2","type":"function"},{"doc":"Same as ap/2, but with all functions curried. Examples iex&gt; [fn x -&gt; x + 1 end, fn y -&gt; y * 10 end] &lt;&lt;~ [1, 2, 3] [2, 3, 4, 10, 20, 30] iex&gt; import Realm.Functor ...&gt; ...&gt; [100, 200] ...&gt; ~&gt; fn(x, y, z) -&gt; x * y / z end ...&gt; |&gt; provide([5, 2]) ...&gt; |&gt; provide([100, 50]) ...&gt; |&gt; provide(fn x -&gt; x + 1 end) [6.0, 11.0, 3.0, 5.0, 11.0, 21.0, 5.0, 9.0] iex&gt; import Realm.Functor, only: [&lt;~: 2] ...&gt; fn(a, b, c, d) -&gt; a * b - c + d end &lt;~ [1, 2] |&gt; provide([3, 4]) |&gt; provide([5, 6]) |&gt; provide([7, 8]) [5, 6, 4, 5, 6, 7, 5, 6, 8, 9, 7, 8, 10, 11, 9, 10]","ref":"Realm.html#provide/2","title":"Realm.provide/2","type":"function"},{"doc":"Same as convey/2, but with all functions curried. Examples iex&gt; [1, 2, 3] ~&gt;&gt; [fn x -&gt; x + 1 end, fn y -&gt; y * 10 end] [2, 10, 3, 20, 4, 30] iex&gt; import Realm.Functor ...&gt; ...&gt; [100, 50] ...&gt; |&gt; supply([5, 2] # Note the bracket ...&gt; |&gt; supply([100, 200] # on both `Apply` lines ...&gt; ~&gt; fn(x, y, z) -&gt; x * y / z end)) [5.0, 10.0, 2.0, 4.0, 10.0, 20.0, 4.0, 8.0]","ref":"Realm.html#supply/2","title":"Realm.supply/2","type":"function"},{"doc":"map/2 but with the function automatically curried Examples iex&gt; [1, 2, 3] ...&gt; ~&gt; fn x -&gt; x + 55 end ...&gt; ~&gt; fn y -&gt; y * 10 end [560, 570, 580] iex&gt; [1, 2, 3] ...&gt; ~&gt; fn(x, y) -&gt; x + y end ...&gt; |&gt; List.first() ...&gt; |&gt; apply([9]) 10","ref":"Realm.html#~%3E/2","title":"Realm.~>/2","type":"function"},{"doc":"Same as convey/2, but with all functions curried. Examples iex&gt; [1, 2, 3] ~&gt;&gt; [fn x -&gt; x + 1 end, fn y -&gt; y * 10 end] [2, 10, 3, 20, 4, 30] iex&gt; import Realm.Functor ...&gt; ...&gt; [100, 50] ...&gt; ~&gt;&gt; ([5, 2] # Note the bracket ...&gt; ~&gt;&gt; ([100, 200] # on both `Apply` lines ...&gt; ~&gt; fn(x, y, z) -&gt; x * y / z end)) [5.0, 10.0, 2.0, 4.0, 10.0, 20.0, 4.0, 8.0]","ref":"Realm.html#~%3E%3E/2","title":"Realm.~>>/2","type":"function"},{"doc":"An extension of Realm.Functor, Apply provides a way to apply arguments to functions when both are apply in the same kind of container. This can be seen as running function application &quot;in a context&quot;. For a nice, illustrated introduction, see Functors, Applicatives, And Monads In Pictures. Graphically If function application looks like this data |&gt; function == result and a functor looks like this %Container&lt;data&gt; ~&gt; function == %Container&lt;result&gt; then an apply looks like %Container&lt;data&gt; ~&gt;&gt; %Container&lt;function&gt; == %Container&lt;result&gt; which is similar to function application inside containers, plus the ability to attach special effects to applications. data --------------- function ---------------&gt; result %Container&lt;data&gt; --- %Container&lt;function&gt; ---&gt; %Container&lt;result&gt; This lets us do functorial things like continue applying values to a curried function resulting from a Realm.Functor.map/2 apply multiple functions to multiple arguments (with lists) propogate some state (like Nothing in Algae.Maybe) but now with a much larger number of arguments, reuse partially applied functions, and run effects with the function container as well as the data container. Examples iex&gt; ap([fn x -&gt; x + 1 end, fn y -&gt; y * 10 end], [1, 2, 3]) [2, 3, 4, 10, 20, 30] iex&gt; [100, 200] ...&gt; |&gt; Realm.Functor.map(curry(fn)(x, y, z) -&gt; x * y / z end) ...&gt; |&gt; provide([5, 2]) ...&gt; |&gt; provide([100, 50]) [5.0, 10.0, 2.0, 4.0, 10.0, 20.0, 4.0, 8.0] # ↓ ↓ # 100 * 5 / 100 200 * 5 / 50 iex&gt; import Realm.Functor ...&gt; ...&gt; [100, 200] ...&gt; ~&gt; fn(x, y, z) -&gt; ...&gt; x * y / z ...&gt; end &lt;&lt;~ [5, 2] ...&gt; &lt;&lt;~ [100, 50] [5.0, 10.0, 2.0, 4.0, 10.0, 20.0, 4.0, 8.0] # ↓ ↓ # 100 * 5 / 100 200 * 5 / 50 %Algae.Maybe.Just{just: 42} ~&gt; fn(x, y, z) -&gt; x * y / z end &lt;&lt;~ %Algae.Maybe.Nothing{} &lt;&lt;~ %Algae.Maybe.Just{just: 99} #=&gt; %Algae.Maybe.Nothing{} convey vs ap convey and ap essentially associate in opposite directions. For example, large data is usually more efficient with ap, and large numbers of functions are usually more efficient with convey. It&#39;s also more consistent consistency. In Elixir, we like to think of a &quot;subject&quot; being piped through a series of transformations. This places the function argument as the second argument. In Realm.Functor, this was of little consequence. However, in Apply, we&#39;re essentially running superpowered function application. ap is short for apply, as to not conflict with Kernel.apply/2, and is meant to respect a similar API, with the function as the first argument. This also reads nicely when piped, as it becomes [funs] |&gt; ap([args1]) |&gt; ap([args2]), which is similar in structure to fun.(arg2).(arg1). With potentially multiple functions being applied over potentially many arguments, we need to worry about ordering. convey not only flips the order of arguments, but also who is in control of ordering. convey typically runs each function over all arguments (first_fun ⬸ all_args), and ap runs all functions for each element (first_arg ⬸ all_funs). This may change the order of results, and is a feature, not a bug. iex&gt; [1, 2, 3] ...&gt; |&gt; Realm.Apply.convey([&amp;(&amp;1 + 1), &amp;(&amp;1 * 10)]) [ 2, 10, # [(1 + 1), (1 * 10)] 3, 20, # [(2 + 1), (2 * 10)] 4, 30 # [(3 + 1), (3 * 10)] ] iex&gt; [&amp;(&amp;1 + 1), &amp;(&amp;1 * 10)] ...&gt; |&gt; ap([1, 2, 3]) [ 2, 3, 4, # [(1 + 1), (2 + 1), (3 + 1)] 10, 20, 30 # [(1 * 10), (2 * 10), (3 * 10)] ] Type Class An instance of Realm.Apply must also implement Realm.Functor, and define Realm.Apply.convey/2. Functor [map/2] ↓ Apply [convey/2]","ref":"Realm.Apply.html","title":"Realm.Apply","type":"protocol"},{"doc":"Pipe arguments to functions, when both are apply in the same type of data structure. Examples iex&gt; [1, 2, 3] ...&gt; |&gt; Apply.convey([fn x -&gt; x + 1 end, fn y -&gt; y * 10 end]) [2, 10, 3, 20, 4, 30]","ref":"Realm.Apply.html#convey/2","title":"Realm.Apply.convey/2","type":"function"},{"doc":"","ref":"Realm.Apply.html#t:t/0","title":"Realm.Apply.t/0","type":"type"},{"doc":"","ref":"Realm.Apply.Algebra.html","title":"Realm.Apply.Algebra","type":"module"},{"doc":"Reverse arguments and sequencing of convey/2. Conceptually this makes operations happen in a different order than convey/2, with the left-side arguments (functions) being run on all right-side arguments, in that order. We&#39;re altering the sequencing of function applications. Examples iex&gt; import Realm.Apply.Algebra ...&gt; ap([fn x -&gt; x + 1 end, fn y -&gt; y * 10 end], [1, 2, 3]) [2, 3, 4, 10, 20, 30] # For comparison iex&gt; Apply.convey([1, 2, 3], [fn x -&gt; x + 1 end, fn y -&gt; y * 10 end]) [2, 10, 3, 20, 4, 30] iex&gt; [100, 200] ...&gt; |&gt; Realm.Functor.map(curry(fn)(x, y, z) -&gt; x * y / z end) ...&gt; |&gt; ap([5, 2]) ...&gt; |&gt; ap([100, 50]) [5.0, 10.0, 2.0, 4.0, 10.0, 20.0, 4.0, 8.0] # ↓ ↓ # 100 * 5 / 100 200 * 5 / 50","ref":"Realm.Apply.Algebra.html#ap/2","title":"Realm.Apply.Algebra.ap/2","type":"function"},{"doc":"Sequence actions, replacing the last argument with the first argument&#39;s values This is essentially a sequence of actions forgetting the second argument Examples iex&gt; import Realm.Apply.Algebra ...&gt; [1, 2, 3] ...&gt; |&gt; following([3, 4, 5]) ...&gt; |&gt; following([5, 6, 7]) [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3 ] iex&gt; import Realm.Apply.Algebra ...&gt; {1, 2, 3} |&gt; following({4, 5, 6}) |&gt; following({7, 8, 9}) {12, 15, 3}","ref":"Realm.Apply.Algebra.html#following/2","title":"Realm.Apply.Algebra.following/2","type":"function"},{"doc":"Alias for convey/2. Why &quot;hose&quot;? Pipes (|&gt;) are application with arguments flipped ap/2 is like function application &quot;in a context&quot; The opposite of ap is a contextual pipe hoses are a kind of flexible pipe Q.E.D. Examples iex&gt; [1, 2, 3] ...&gt; |&gt; hose([fn x -&gt; x + 1 end, fn y -&gt; y * 10 end]) [2, 10, 3, 20, 4, 30]","ref":"Realm.Apply.Algebra.html#hose/2","title":"Realm.Apply.Algebra.hose/2","type":"function"},{"doc":"Extends Functor.map/2 to apply arguments to a binary function Examples iex&gt; import Realm.Apply.Algebra ...&gt; lift([1, 2], [3, 4], &amp;+/2) [4, 5, 5, 6] iex&gt; import Realm.Apply.Algebra ...&gt; [1, 2] ...&gt; |&gt; lift([3, 4], &amp;*/2) [3, 6, 4, 8]","ref":"Realm.Apply.Algebra.html#lift/3","title":"Realm.Apply.Algebra.lift/3","type":"function"},{"doc":"Extends lift to apply arguments to a ternary function Examples iex&gt; import Realm.Apply.Algebra ...&gt; lift([1, 2], [3, 4], [5, 6], fn(a, b, c) -&gt; a * b - c end) [-2, -3, 1, 0, -1, -2, 3, 2]","ref":"Realm.Apply.Algebra.html#lift/4","title":"Realm.Apply.Algebra.lift/4","type":"function"},{"doc":"Extends lift to apply arguments to a quaternary function Examples iex&gt; import Realm.Apply.Algebra ...&gt; lift([1, 2], [3, 4], [5, 6], [7, 8], fn(a, b, c, d) -&gt; a * b - c + d end) [5, 6, 4, 5, 8, 9, 7, 8, 6, 7, 5, 6, 10, 11, 9, 10]","ref":"Realm.Apply.Algebra.html#lift/5","title":"Realm.Apply.Algebra.lift/5","type":"function"},{"doc":"Extends over to apply arguments to a binary function Examples iex&gt; over(&amp;+/2, [1, 2], [3, 4]) [4, 5, 5, 6] iex&gt; (&amp;*/2) ...&gt; |&gt; over([1, 2], [3, 4]) [3, 4, 6, 8]","ref":"Realm.Apply.Algebra.html#over/3","title":"Realm.Apply.Algebra.over/3","type":"function"},{"doc":"Extends over to apply arguments to a ternary function Examples iex&gt; import Realm.Apply.Algebra ...&gt; fn(a, b, c) -&gt; a * b - c end ...&gt; |&gt; over([1, 2], [3, 4], [5, 6]) [-2, -3, -1, -2, 1, 0, 3, 2]","ref":"Realm.Apply.Algebra.html#over/4","title":"Realm.Apply.Algebra.over/4","type":"function"},{"doc":"Extends over to apply arguments to a ternary function Examples iex&gt; import Realm.Apply.Algebra ...&gt; fn(a, b, c) -&gt; a * b - c end ...&gt; |&gt; over([1, 2], [3, 4], [5, 6]) [-2, -3, -1, -2, 1, 0, 3, 2]","ref":"Realm.Apply.Algebra.html#over/5","title":"Realm.Apply.Algebra.over/5","type":"function"},{"doc":"Sequence actions, replacing the first/previous values with the last argument This is essentially a sequence of actions forgetting the first argument Examples iex&gt; import Realm.Apply.Algebra ...&gt; [1, 2, 3] ...&gt; |&gt; then([4, 5, 6]) ...&gt; |&gt; then([7, 8, 9]) [ 7, 8, 9, 7, 8, 9, 7, 8, 9, 7, 8, 9, 7, 8, 9, 7, 8, 9, 7, 8, 9, 7, 8, 9, 7, 8, 9 ] iex&gt; import Realm.Apply.Algebra ...&gt; {1, 2, 3} |&gt; then({4, 5, 6}) |&gt; then({7, 8, 9}) {12, 15, 9}","ref":"Realm.Apply.Algebra.html#then/2","title":"Realm.Apply.Algebra.then/2","type":"function"},{"doc":"Arrows abstract the idea of computations, potentially with a context. Arrows are in fact an abstraction above monads, and can be used both to express all other type classes in Realm. They also enable some nice flow-based reasoning about computation. For a nice illustrated explination, see Haskell/Understanding arrows Arrows let you think diagrammatically, and is a powerful way of thinking about flow programming, concurrency, and more. ┌---&gt; f --------------------------┐ | v input ---&gt; split unsplit ---&gt; result | ^ | ┌--- h ---┐ | | | v | └---&gt; g ---&gt; split unsplit ---┘ | ^ └--- i ---┘ Type Class An instance of Realm.Arrow must also implement Realm.Category, and define Realm.Arrow.arrowize/2. Semigroupoid [compose/2, apply/2] ↓ Category [identity/1] ↓ Arrow [arrowize/2]","ref":"Realm.Arrow.html","title":"Realm.Arrow","type":"protocol"},{"doc":"Lift a function into an arrow, much like how of/2 does with data. Essentially a label for composing functions end-to-end, where instances may have their own special idea of what composition means. The simplest example is a regular function. Others are possible, such as Kleisli arrows. Examples iex&gt; use Realm.Arrow ...&gt; times_ten = arrowize(fn -&gt; nil end, &amp;(&amp;1 * 10)) ...&gt; 5 |&gt; Realm.pipe(times_ten) 50","ref":"Realm.Arrow.html#arrowize/2","title":"Realm.Arrow.arrowize/2","type":"function"},{"doc":"","ref":"Realm.Arrow.html#t:t/0","title":"Realm.Arrow.t/0","type":"type"},{"doc":"","ref":"Realm.Arrow.Algebra.html","title":"Realm.Arrow.Algebra","type":"module"},{"doc":"Target the first element of a tuple. Examples iex&gt; import Realm.Arrow.Algebra ...&gt; first(fn x -&gt; x * 50 end).({1, 1}) {50, 1}","ref":"Realm.Arrow.Algebra.html#first/1","title":"Realm.Arrow.Algebra.first/1","type":"function"},{"doc":"The identity function lifted into an arrow of the correct type. Examples iex&gt; id_arrow(fn -&gt; nil end).(99) 99","ref":"Realm.Arrow.Algebra.html#id_arrow/1","title":"Realm.Arrow.Algebra.id_arrow/1","type":"function"},{"doc":"Compose an arrow (left) with a function (right) to produce a new arrow. Examples iex&gt; import Realm.Apply.Algebra ...&gt; f = postcompose( ...&gt; Arrow.arrowize(fn _ -&gt; nil end, fn x -&gt; x + 1 end), ...&gt; fn y -&gt; y * 10 end ...&gt; ) ...&gt; f.(42) 430","ref":"Realm.Arrow.Algebra.html#postcompose/2","title":"Realm.Arrow.Algebra.postcompose/2","type":"function"},{"doc":"Compose a function (left) with an arrow (right) to produce a new arrow. Examples iex&gt; import Realm.Apply.Algebra ...&gt; f = precompose( ...&gt; fn x -&gt; x + 1 end, ...&gt; Arrow.arrowize(fn _ -&gt; nil end, fn y -&gt; y * 10 end) ...&gt; ) ...&gt; f.(42) 430","ref":"Realm.Arrow.Algebra.html#precompose/2","title":"Realm.Arrow.Algebra.precompose/2","type":"function"},{"doc":"Switch the associativity of a nested tuple. Helpful since many arrows act on a subset of a tuple, and you may want to move portions in and out of that stream. Examples iex&gt; import Realm.Apply.Algebra ...&gt; reassociate({1, {2, 3}}) {{1, 2}, 3} iex&gt; import Realm.Apply.Algebra ...&gt; reassociate({{1, 2}, 3}) {1, {2, 3}}","ref":"Realm.Arrow.Algebra.html#reassociate/1","title":"Realm.Arrow.Algebra.reassociate/1","type":"function"},{"doc":"Target the second element of a tuple. Examples iex&gt; import Realm.Arrow.Algebra ...&gt; second(fn x -&gt; x * 50 end).({1, 1}) {1, 50}","ref":"Realm.Arrow.Algebra.html#second/1","title":"Realm.Arrow.Algebra.second/1","type":"function"},{"doc":"Copy a single value into both positions of a 2-tuple. This is useful is you want to run functions on the input separately. Examples iex&gt; import Realm.Arrow.Algebra ...&gt; split(42) {42, 42} iex&gt; import Realm.Arrow.Algebra ...&gt; 5 ...&gt; |&gt; split() ...&gt; |&gt; (second(fn x -&gt; x - 2 end) ...&gt; &lt;~&gt; first(fn y -&gt; y * 10 end) ...&gt; &lt;~&gt; second(&amp;inspect/1)).() {50, &quot;3&quot;} iex&gt; import Realm.Arrow.Algebra ...&gt; import Realm.Semigroupoid.Algebra ...&gt; 5 ...&gt; |&gt; split() ...&gt; |&gt; pipe(second(fn x -&gt; x - 2 end)) ...&gt; |&gt; pipe(first(fn y -&gt; y * 10 end)) ...&gt; |&gt; pipe(second(&amp;inspect/1)) {50, &quot;3&quot;}","ref":"Realm.Arrow.Algebra.html#split/1","title":"Realm.Arrow.Algebra.split/1","type":"function"},{"doc":"Swap positions of elements in a tuple. Examples iex&gt; swap({1, 2}) {2, 1}","ref":"Realm.Arrow.Algebra.html#swap/1","title":"Realm.Arrow.Algebra.swap/1","type":"function"},{"doc":"Merge two tuple values with a combining function. Examples iex&gt; import Realm.Apply.Algebra ...&gt; unsplit({1, 2}, &amp;+/2) 3","ref":"Realm.Arrow.Algebra.html#unsplit/2","title":"Realm.Arrow.Algebra.unsplit/2","type":"function"},{"doc":"A category is some collection of objects and relationships (morphisms) between them. This idea is captured by the notion of an identity function for objects, and the ability to compose relationships between objects. In most cases, these are very straightforward, and composition and identity are the standard functions from the Quark package or similar. Type Class An instance of Realm.Category must also implement Realm.Semigroupoid, and define Realm.Category.identity/1. Semigroupoid [compose/2, apply/2] ↓ Category [identity/1]","ref":"Realm.Category.html","title":"Realm.Category","type":"protocol"},{"doc":"Take some value and return it again. Examples iex&gt; classic_id = Realm.Category.identity(fn -&gt; nil end) ...&gt; classic_id.(42) 42","ref":"Realm.Category.html#identity/1","title":"Realm.Category.identity/1","type":"function"},{"doc":"","ref":"Realm.Category.html#t:t/0","title":"Realm.Category.t/0","type":"type"},{"doc":"Functors are datatypes that allow the application of functions to their interior values. Always returns data in the same structure (same size, tree layout, and so on). Please note that bitstrings are not functors, as they fail the functor composition constraint. They change the structure of the underlying data, and thus composed lifting does not equal lifing a composed function. If you need to map over a bitstring, convert it to and from a charlist. Type Class An instance of Realm.Functor must define Realm.Functor.map/2. Functor [map/2]","ref":"Realm.Functor.html","title":"Realm.Functor","type":"protocol"},{"doc":"map a function into one layer of a data wrapper. There is an autocurrying variant: lift/2. Examples iex&gt; Realm.Functor.map([1, 2, 3], fn x -&gt; x + 1 end) [2, 3, 4] iex&gt; %{a: 1, b: 2} ~&gt; fn x -&gt; x * 10 end %{a: 10, b: 20} iex&gt; Realm.Functor.map(%{a: 2, b: [1, 2, 3]}, fn ...&gt; int when is_integer(int) -&gt; int * 100 ...&gt; value -&gt; inspect(value) ...&gt; end) %{a: 200, b: &quot;[1, 2, 3]&quot;}","ref":"Realm.Functor.html#map/2","title":"Realm.Functor.map/2","type":"function"},{"doc":"","ref":"Realm.Functor.html#t:t/0","title":"Realm.Functor.t/0","type":"type"},{"doc":"","ref":"Realm.Functor.Algebra.html","title":"Realm.Functor.Algebra","type":"module"},{"doc":"Replace all inner elements with a constant value Examples iex&gt; import Realm.Functor.Algebra ...&gt; replace([1, 2, 3], &quot;hi&quot;) [&quot;hi&quot;, &quot;hi&quot;, &quot;hi&quot;]","ref":"Realm.Functor.Algebra.html#replace/2","title":"Realm.Functor.Algebra.replace/2","type":"function"},{"doc":"Monoid extends the semigroup with the concept of an &quot;empty&quot; or &quot;zero&quot; element. Type Class An instance of Realm.Monoid must also implement Realm.Semigroup, and define Realm.Monoid.empty/1. Semigroup [append/2] ↓ Monoid [empty/1]","ref":"Realm.Monoid.html","title":"Realm.Monoid","type":"protocol"},{"doc":"An &quot;emptied out&quot; or &quot;starting position&quot; of the passed data. Example iex&gt; Realm.Monoid.empty(10) 0 iex&gt; Realm.Monoid.empty [1, 2, 3, 4, 5] []","ref":"Realm.Monoid.html#empty/1","title":"Realm.Monoid.empty/1","type":"function"},{"doc":"","ref":"Realm.Monoid.html#t:t/0","title":"Realm.Monoid.t/0","type":"type"},{"doc":"","ref":"Realm.Monoid.Algebra.html","title":"Realm.Monoid.Algebra","type":"module"},{"doc":"map with its arguments flipped. Examples iex&gt; import Realm.Monoid.Algebra ...&gt; across(fn x -&gt; x + 1 end, [1, 2, 3]) [2, 3, 4] iex&gt; import Realm.Monoid.Algebra ...&gt; fn ...&gt; int when is_integer(int) -&gt; int * 100 ...&gt; value -&gt; inspect(value) ...&gt; end ...&gt; |&gt; .across(%{a: 2, b: [1, 2, 3]}) %{a: 200, b: &quot;[1, 2, 3]&quot;}","ref":"Realm.Monoid.Algebra.html#across/2","title":"Realm.Monoid.Algebra.across/2","type":"function"},{"doc":"Check if a value is the empty element of that type. Examples iex&gt; import Realm.Monoid.Algebra ...&gt; empty?([]) true iex&gt; import Realm.Monoid.Algebra ...&gt; empty?([1]) false","ref":"Realm.Monoid.Algebra.html#empty?/1","title":"Realm.Monoid.Algebra.empty?/1","type":"function"},{"doc":"","ref":"Realm.Monoid.Algebra.html#zero/1","title":"Realm.Monoid.Algebra.zero/1","type":"function"},{"doc":"Ord describes how to order elements of a data type. This is a total order, so all elements are either :equal, :greater, or :lesser than each other. Type Class An instance of Realm.Ord must also implement Realm.Setoid, and define Realm.Ord.compare/2. Setoid [equivalent?/2] ↓ Ord [compare/2]","ref":"Realm.Ord.html","title":"Realm.Ord","type":"protocol"},{"doc":"Get the ordering relationship between two elements. Possible results are :lesser, :equal, and :greater Examples iex&gt; Realm.Ord.compare(1, 1) :equal iex&gt; Realm.Ord.compare([1], [2]) :lesser iex&gt; Realm.Ord.compare([1, 2], [3]) :lesser iex&gt; Realm.Ord.compare([3, 2, 1], [1, 2, 3, 4, 5]) :greater","ref":"Realm.Ord.html#compare/2","title":"Realm.Ord.compare/2","type":"function"},{"doc":"","ref":"Realm.Ord.html#t:ordering/0","title":"Realm.Ord.ordering/0","type":"type"},{"doc":"","ref":"Realm.Ord.html#t:t/0","title":"Realm.Ord.t/0","type":"type"},{"doc":"","ref":"Realm.Ord.Algebra.html","title":"Realm.Ord.Algebra","type":"module"},{"doc":"Determine if two elements are :equal. Examples iex&gt; import Realm.Monoid.Algebra ...&gt; equal?(1, 1.0) true iex&gt; import Realm.Monoid.Algebra ...&gt; equal?(1, 2) false","ref":"Realm.Ord.Algebra.html#equal?/2","title":"Realm.Ord.Algebra.equal?/2","type":"function"},{"doc":"A semigroup is a structure describing data that can be appendenated with others of its type. That is to say that appending another list returns a list, appending one map to another returns a map, and appending two integers returns an integer, and so on. These can be chained together an arbitrary number of times. For example: 1 &lt;&gt; 2 &lt;&gt; 3 &lt;&gt; 5 &lt;&gt; 7 == 18 [1, 2, 3] &lt;&gt; [4, 5, 6] &lt;&gt; [7, 8, 9] == [1, 2, 3, 4, 5, 6, 7, 8, 9] &quot;foo&quot; &lt;&gt; &quot; &quot; &lt;&gt; &quot;bar&quot; == &quot;foo bar&quot; This generalizes the idea of a monoid, as it does not require an empty version. Type Class An instance of Realm.Semigroup must define Realm.Semigroup.append/2. Semigroup [append/2]","ref":"Realm.Semigroup.html","title":"Realm.Semigroup","type":"protocol"},{"doc":"appendenate two data of the same type. These can be chained together an arbitrary number of times. For example: iex&gt; 1 |&gt; append(2) |&gt; append(3) 6 iex&gt; [1, 2, 3] ...&gt; |&gt; append([4, 5, 6]) ...&gt; |&gt; append([7, 8, 9]) [1, 2, 3, 4, 5, 6, 7, 8, 9] iex&gt; &quot;foo&quot; |&gt; append(&quot; &quot;) |&gt; append(&quot;bar&quot;) &quot;foo bar&quot;","ref":"Realm.Semigroup.html#append/2","title":"Realm.Semigroup.append/2","type":"function"},{"doc":"","ref":"Realm.Semigroup.html#t:t/0","title":"Realm.Semigroup.t/0","type":"type"},{"doc":"","ref":"Realm.Semigroup.Algebra.html","title":"Realm.Semigroup.Algebra","type":"module"},{"doc":"Flatten a list of homogeneous semigroups to a single container. Example iex&gt; import Realm.Semigroup.Algebra ...&gt; concat [ ...&gt; [1, 2, 3], ...&gt; [4, 5, 6] ...&gt; ] [1, 2, 3, 4, 5, 6]","ref":"Realm.Semigroup.Algebra.html#concat/1","title":"Realm.Semigroup.Algebra.concat/1","type":"function"},{"doc":"Repeat the contents of a semigroup a certain number of times. Examples iex&gt; import Realm.Semigroup.Algebra ...&gt; [1, 2, 3] |&gt; repeat(3) [1, 2, 3, 1, 2, 3, 1, 2, 3]","ref":"Realm.Semigroup.Algebra.html#repeat/2","title":"Realm.Semigroup.Algebra.repeat/2","type":"function"},{"doc":"A semigroupoid describes some way of composing morphisms on between some collection of objects. Type Class An instance of Realm.Semigroupoid must define Realm.Semigroupoid.compose/2. Semigroupoid [compose/2]","ref":"Realm.Semigroupoid.html","title":"Realm.Semigroupoid","type":"protocol"},{"doc":"Express how to apply arguments to the very end of a semigroupoid, or &quot;run the morphism&quot;. This should not be used to inject values part way though a composition chain. It is provided here to remain idiomatic with Elixir, and to make prop testing possible. Examples iex&gt; Realm.Semigroupoid.apply(&amp;inspect/1, [42]) &quot;42&quot;","ref":"Realm.Semigroupoid.html#apply/2","title":"Realm.Semigroupoid.apply/2","type":"function"},{"doc":"Take two morphisms and return their composition &quot;the math way&quot;. That is, (b -&gt; c) -&gt; (a -&gt; b) -&gt; (a -&gt; c). Examples iex&gt; times_ten_plus_one = compose(fn x -&gt; x + 1 end, fn y -&gt; y * 10 end) ...&gt; times_ten_plus_one.(5) 51","ref":"Realm.Semigroupoid.html#compose/2","title":"Realm.Semigroupoid.compose/2","type":"function"},{"doc":"","ref":"Realm.Semigroupoid.html#t:t/0","title":"Realm.Semigroupoid.t/0","type":"type"},{"doc":"","ref":"Realm.Semigroupoid.Algebra.html","title":"Realm.Semigroupoid.Algebra","type":"module"},{"doc":"compose/2, but with the arguments flipped (same direction as |&gt;). Examples iex&gt; import Realm.Semigroupoid.Algebra ...&gt; times_ten_plus_one = compose(fn y -&gt; y * 10 end, fn x -&gt; x + 1 end) ...&gt; times_ten_plus_one.(5) 51","ref":"Realm.Semigroupoid.Algebra.html#compose/2","title":"Realm.Semigroupoid.Algebra.compose/2","type":"function"},{"doc":"Pipe some data through a morphism. Similar to apply/2, but with a single argument, not needing to wrap the argument in a list. Examples iex&gt; import Realm.Semigroupoid.Algebra ...&gt; pipe(42, &amp;(&amp;1 + 1)) 43","ref":"Realm.Semigroupoid.Algebra.html#pipe/2","title":"Realm.Semigroupoid.Algebra.pipe/2","type":"function"},{"doc":"A setoid is a type with an equivalence relation. This is most useful when equivalence of some data is not the same as equality. Since some types have differing concepts of equality, this allows overriding the behaviour from Kernel.==/2. To get the Setoid == operator override, simply use Realm.Setoid. Type Class An instance of Realm.Setoid must define Realm.Setoid.equivalent?/2 Setoid [equivalent?/2]","ref":"Realm.Setoid.html","title":"Realm.Setoid","type":"protocol"},{"doc":"Compare two setoids and determine if they are equivalent. Aliased as ==. Examples iex&gt; equivalent?(1, 2) false iex&gt; import Kernel, except: [==: 2, !=: 2] ...&gt; %{a: 1} == %{a: 1, b: 2} false equivalent?(%Maybe.Just{just: 42}, %Maybe.Nothing{}) #=&gt; false Equivalence not equality baby_harry = %Wizard{name: &quot;Harry Potter&quot;, age: 10} old_harry = %Wizard{name: &quot;Harry Potter&quot;, age: 17} def chosen_one?(some_wizard), do: equivalent?(baby_harry, some_wizard) chosen_one?(old_harry) #=&gt; true","ref":"Realm.Setoid.html#equivalent?/2","title":"Realm.Setoid.equivalent?/2","type":"function"},{"doc":"","ref":"Realm.Setoid.html#t:t/0","title":"Realm.Setoid.t/0","type":"type"},{"doc":"Realm A simple implementation of composable polymorphic functions and operators based on the implementation of Haskell&#39;s category theory using native Elixir Protocol.","ref":"readme.html","title":"Realm","type":"extras"},{"doc":"def deps do [ {:realm, &quot;~&gt; 0.1.0&quot;} ] end","ref":"readme.html#installation","title":"Realm - Installation","type":"extras"}]